﻿using System;
using FileArrangement.Plugins;

namespace FileArrangement.App
{
	public class ListBoxItem
	{
		private string Name;

		public ListBoxItem( object value )
		{
			if ( value == null )
			{
				throw new ArgumentNullException( "value" );
			}

			Value = value;

			SetUpName( value );
		}

		public object Value { get; private set; }

		private void SetUpName( object value )
		{
			object[] attributes =
				value.GetType().GetCustomAttributes( typeof ( InformationAttribute ), false );

			if ( attributes.Length != 0 )
			{
				InformationAttribute information = (InformationAttribute) attributes[0];

				Name = information.Name;
			}
			else
			{
				Name = value.ToString();
			}
		}

		public override string ToString()
		{
			return Name;
		}
	}
}