﻿using Tomham.IO.FileManipulation;
using Tomham.Windows.Forms.AutoGeneration;

namespace FileArrangement.App
{
	public class NotConditionControllerFactory : ControllerFactory
	{
		public NotConditionControllerFactory( FormHelper formHelper )
		{
			FormHelper = formHelper;
		}

		public FormHelper FormHelper { get; private set; }

		protected override bool IsTarget( object target )
		{
			return target is NotCondition;
		}

		protected override Controller DoCreate( object target )
		{
			return new NotConditionController( target, FormHelper );
		}
	}
}