﻿using System;
using System.Collections.Generic;
using System.Windows.Forms;

namespace FileArrangement.App
{
	public partial class TypeInformationSelectForm : Form
	{
		public TypeInformationSelectForm()
		{
			InitializeComponent();

			Result = new List<TypeInformation>();
		}

		public List<TypeInformation> Result { get; private set; }

		public SelectionMode SelectionMode
		{
			get { return TypeInformationsFilterListBox.SelectionMode; }
			set { TypeInformationsFilterListBox.SelectionMode = value; }
		}

		public void SetTypeInformations( IEnumerable<TypeInformation> informations )
		{
			TypeInformationsFilterListBox.SetSource( informations );
		}

		private void TypeInformationSelectForm_Load( object sender, EventArgs e )
		{
			RootTableLayoutPanel.Dock = DockStyle.Fill;
			okCancelPanel1.Dock = DockStyle.Fill;

			TypeInformationsFilterListBox.Dock = DockStyle.Fill;

			TypeInformationsFilterListBox.IsMatchedItem = IsMatchedItem;
		}

		private bool IsMatchedItem( object item )
		{
			return item.ToString().ToLower().Contains(
				TypeInformationsFilterListBox.FilterText.ToLower() );
		}

		private void okCancelPanel1_OKButton_Click( object sender, EventArgs e )
		{
			Result = TypeInformationsFilterListBox.GetSelectedItems<TypeInformation>();
			DialogResult = DialogResult.OK;
		}

		private void okCancelPanel1_CancelButton_Click( object sender, EventArgs e )
		{
			DialogResult = DialogResult.Cancel;
		}

		private void TypeInformationsFilterListBox_FilterTextChanged(object sender, EventArgs e)
		{
			TypeInformationsFilterListBox.SelectFirstItem();
		}
	}
}