﻿using System;
using System.Collections.Generic;
using System.Windows.Forms;
using EV.Windows.Forms;

namespace FileArrangement.App
{
	public partial class TypeInformationsListUpForm : Form
	{
		private bool Initialized;
		private ListViewSortManager SortManager;

		public TypeInformationsListUpForm()
		{
			InitializeComponent();

			SortManager = new ListViewSortManager(
				TypeInformationsListView,
				new[]
				{
					typeof ( ListViewTextSort ),
					typeof ( ListViewTextSort ),
					typeof ( ListViewTextSort ),
					typeof ( ListViewTextSort ),
					typeof ( ListViewTextSort )
				} );

			TypeInformationsListView.View = View.Details;
			TypeInformationsListView.GridLines = true;
		}

		private void TypeInformationsListUpForm_Load( object sender, EventArgs e )
		{
			TypeInformationsListView.Dock = DockStyle.Fill;
		}

		public void Initialize( List<TypeInformation> list )
		{
			if ( Initialized )
			{
				throw new InvalidOperationException( "2度呼ばないで下さい" );
			}

			TypeInformationsListView.Columns.Add( "名前", 200 );
			TypeInformationsListView.Columns.Add( "説明", 500 );		
			TypeInformationsListView.Columns.Add( "作者" );
			TypeInformationsListView.Columns.Add( "バージョン" );
			TypeInformationsListView.Columns.Add( "場所", 400 );

			foreach ( TypeInformation information in list )
			{
				ListViewItem item = new ListViewItem( information.Name );
				item.SubItems.Add( information.Description );
				item.SubItems.Add( information.Author ); 
				item.SubItems.Add( information.Version );	
				item.SubItems.Add( information.Location );

				TypeInformationsListView.Items.Add( item );
			}

			Initialized = true;
		}
	}
}