﻿using System;
using System.Collections.Generic;
using System.IO;

namespace FileArrangement.Plugins.Common
{
	[ControllerSpecification( typeof ( DateTimeMacroEffectController ) )]
	[Information(
		"日時のマクロ",
		"現在日時: <now>, 作成日時: <creationtime>",
		"tom_ham",
		"1.00"
		)]
	public class DateTimeMacroEffect : MacroEffect
	{
		private const string CreationTimeMacro = "creationtime";
		private const string NowMacro = "now";

		private string FormatStore;

		public string Format
		{
			get
			{
				if ( FormatStore == null )
				{
					FormatStore = "yyyyMMdd";
				}

				return FormatStore;
			}
			set { FormatStore = value; }
		}

		public override IEffect Clone()
		{
			return (IEffect) MemberwiseClone();
		}

		protected override string Calculate( string macro, string sourcePath )
		{
			if ( macro == NowMacro )
			{
				return DateTime.Now.ToString( Format );
			}

			return File.GetCreationTime( sourcePath ).ToString( Format );
		}

		protected override IEnumerable<string> GetMacros()
		{
			return new[] { NowMacro, CreationTimeMacro };
		}
	}
}