﻿using System.Windows.Forms;
using Tomham.Windows.Forms;

namespace FileArrangement.Plugins.Common
{
	public class DateTimeMacroEffectController : AutoAdjustedController<DateTimeMacroEffect>
	{
		private LabeledTextBox FormatLabeledTextBox;

		public DateTimeMacroEffectController( object target ) : base( target )
		{
		}

		public override void UpdateToTarget()
		{
			CastedTarget.Format = FormatLabeledTextBox.TextBox.Text;
		}

		public override void UpdateToControl()
		{
			FormatLabeledTextBox.TextBox.Text = CastedTarget.Format;
		}

		protected override void SetUpContentControls()
		{
			Label titleLabel = new Label
			                   {
			                   	Text = "日時のマクロ",
			                   	AutoSize = true
			                   };

			FormatLabeledTextBox = new LabeledTextBox { TitleText = "フォーマット", Width = 300 };

			AddContent( titleLabel );
			AddContent( FormatLabeledTextBox );
		}
	}
}