﻿using System.Collections.Generic;
using System.IO;

namespace FileArrangement.Plugins.Common
{
	[Information(
		"ファイルネーム要素マクロ",
		"ファイル名: <name>, 拡張子: <ext>",
		"tom_ham",
		"1.00" )]
	public class FileNameElementsMacroEffect : MacroEffect
	{
		private const string ExtensionMacro = "ext";
		private const string NameMacro = "name";

		private readonly string[] Macros = new[] { NameMacro, ExtensionMacro };

		public override IEffect Clone()
		{
			return new FileNameElementsMacroEffect();
		}

		protected override string Calculate( string macro, string sourcePath )
		{
			if ( macro == ExtensionMacro )
			{
				return Path.GetExtension( sourcePath );
			}

			return Path.GetFileNameWithoutExtension( sourcePath );
		}

		protected override IEnumerable<string> GetMacros()
		{
			return Macros;
		}
	}
}