﻿using System.Collections.Generic;
using System.IO;
using System.Reflection;
using System.Text;
using Tomham.Collections.Specialized;
using Tomham.IO;

namespace FileArrangement.Plugins.Common
{
	public class RegExMacroEffectControllerHelper : IGeneral
	{
		private static List<string> HistoryStore;
		private readonly string FileName;

		public RegExMacroEffectControllerHelper()
		{
			FileName = GetFileName();
		}

		public static List<string> History
		{
			get
			{
				if ( HistoryStore == null )
				{
					HistoryStore = new List<string>();
				}

				return HistoryStore;
			}
			set { HistoryStore = value; }
		}

		#region IGeneral Members

		public void Load()
		{
			if ( File.Exists( FileName ) )
			{
				StringList list = new StringList( FileName, Encoding.UTF8 );

				for ( int i = 0; i < list.Count; i++ )
				{
					if ( 50 <= i )
					{
						break;
					}

					History.Add( list[i] );
				}
			}
		}

		public void UnLoad()
		{
			StringList list = new StringList();

			list.AddRange( History );

			list.SaveToFile( FileName, Encoding.UTF8 );
		}

		#endregion

		private string GetFileName()
		{
			Assembly assembly = Assembly.GetExecutingAssembly();

			DirectoryInfo info = Directory.GetParent( assembly.Location );

			return PathUtils.Combine( info.FullName, "RegExMacroEffectPatternHistory.dat" );
		}
	}
}