﻿using System.IO;
using Tomham.IO.FileManipulation;

namespace FileArrangement.Plugins.Common
{
	[ControllerSpecification( typeof ( SizeConditionController ) )]
	[Information(
		"サイズ",
		"0KB - 10GBまでの値を使用できます",
		"tom_ham",
		"1.00" )]
	public class SizeCondition : ICondition
	{
		public int BaseValue { get; set; }
		public bool OrAbove { get; set; }

		#region ICondition Members

		public bool IsMatch( MatchArguments arguments )
		{
			int size = BaseValue * 1000;

			FileInfo info = new FileInfo( arguments.Source );

			if ( OrAbove )
			{
				return size <= info.Length;
			}
			else
			{
				return info.Length <= size;
			}
		}

		public ICondition Clone()
		{
			return (ICondition) MemberwiseClone();
		}

		#endregion
	}
}