﻿using System;
using System.Windows.Forms;

namespace FileArrangement.Plugins.Common
{
	public class SizeConditionController : AutoAdjustedController<SizeCondition>
	{
		private NumericUpDown BaseValueNumericUpDown;
		private ComboBox OrAboveComboBox;

		public SizeConditionController( object target ) : base( target )
		{
		}

		public override void UpdateToTarget()
		{
			CastedTarget.BaseValue = Convert.ToInt32( BaseValueNumericUpDown.Value );

			if ( OrAboveComboBox.SelectedIndex == 0 )
			{
				CastedTarget.OrAbove = true;
			}
			else
			{
				CastedTarget.OrAbove = false;
			}
		}

		public override void UpdateToControl()
		{
			BaseValueNumericUpDown.Value = CastedTarget.BaseValue;

			if ( CastedTarget.OrAbove )
			{
				OrAboveComboBox.SelectedIndex = 0;
			}
			else
			{
				OrAboveComboBox.SelectedIndex = 1;
			}
		}

		protected override void SetUpContentControls()
		{
			Label titleLabel = new Label
			                   {
			                   	Text = "サイズ",
			                   	AutoSize = true
			                   };

			Panel panel = new Panel { AutoSize = true };

			BaseValueNumericUpDown = new NumericUpDown
			                         {
			                         	ThousandsSeparator = true,
			                         	Minimum = 0,
			                         	Maximum = 10000000,
			                         	Width = 80
			                         };

			Label sizeUnitLable = new Label
			                      {
			                      	Text = "KB",
			                      	Width = 20,
			                      	Left = BaseValueNumericUpDown.Right + 5,
			                      	Top = BaseValueNumericUpDown.Top + 3
			                      };

			OrAboveComboBox = new ComboBox { AutoSize = true, DropDownStyle = ComboBoxStyle.DropDownList, Width = 50 };
			OrAboveComboBox.Items.AddRange( new object[] { "以上", "以下" } );
			OrAboveComboBox.Left = sizeUnitLable.Right + 5;

			AddContent( titleLabel );
			AddContent( panel );

			panel.Controls.Add( BaseValueNumericUpDown );
			panel.Controls.Add( sizeUnitLable );
			panel.Controls.Add( OrAboveComboBox );
		}
	}
}