﻿using System;

namespace FileArrangement.Plugins
{
	[AttributeUsage( AttributeTargets.Class, Inherited = false )]
	public class InformationAttribute : Attribute
	{
		private readonly string AuthorStore;
		private readonly string DescriptionStore;
		private readonly string NameStore;
		private readonly string VersionStore;

		public InformationAttribute( string name, string description, string author, string version )
		{
			NameStore = name;
			DescriptionStore = description;
			AuthorStore = author;
			VersionStore = version;
		}

		public string Name
		{
			get { return NameStore; }
		}

		public string Description
		{
			get { return DescriptionStore; }
		}

		public string Author
		{
			get { return AuthorStore; }
		}

		public string Version
		{
			get { return VersionStore; }
		}
	}
}