﻿using System.Collections.Generic;

namespace FileArrangement.Plugins
{
	public class MessageBoard
	{
		private readonly List<string> Messages = new List<string>();

		public string[] GetAndClearMessages()
		{
			lock ( Messages )
			{
				string[] result = Messages.ToArray();

				Messages.Clear();

				return result;
			}
		}

		public void AddMessages( params string[] messages )
		{
			lock ( Messages )
			{
				Messages.AddRange( messages );
			}
		}
	}
}