﻿using System;
using System.Collections.Generic;

namespace FileArrangement
{
	[Serializable]
	public class RuleSet
	{
		private string NameStore;
		private List<Rule> RulesStore;
		private List<string> SourceDirectoriesStore;
		private TargetEntry TargetEntryStore = TargetEntry.Files;

		public string Name
		{
			get
			{
				if ( NameStore == null )
				{
					NameStore = string.Empty;
				}

				return NameStore;
			}
			set { NameStore = value; }
		}

		public TargetEntry TargetEntry
		{
			get { return TargetEntryStore; }
			set { TargetEntryStore = value; }
		}

		public List<string> SourceDirectories
		{
			get
			{
				if ( SourceDirectoriesStore == null )
				{
					SourceDirectoriesStore = new List<string>();
				}

				return SourceDirectoriesStore;
			}
			set { SourceDirectoriesStore = value; }
		}

		public List<Rule> Rules
		{
			get
			{
				if ( RulesStore == null )
				{
					RulesStore = new List<Rule>();
				}

				return RulesStore;
			}
			set { RulesStore = value; }
		}

		public RuleSet Clone()
		{
			RuleSet clone = new RuleSet();
			clone.Name = Name;
			clone.TargetEntry = TargetEntry;
			clone.SourceDirectories.AddRange( SourceDirectories );

			foreach ( Rule rule in Rules )
			{
				clone.Rules.Add( rule.Clone() );
			}

			return clone;
		}

		public override string ToString()
		{
			return Name;
		}
	}
}