﻿using System;

namespace FileArrangement
{
	public class TypeInformation
	{
		public override string ToString()
		{
			return Name;
		}

		private readonly string AuthorStore;
		private readonly string DescriptionStore;
		private readonly string LocationStore;
		private readonly string NameStore;
		private readonly Type TypeStore;
		private readonly string VersionStore;

		public TypeInformation( Type type, string name, string description, string author, string version, string location )
		{
			AuthorStore = author;
			DescriptionStore = description;
			LocationStore = location;
			NameStore = name;
			TypeStore = type;
			VersionStore = version;
		}

		public string Name
		{
			get { return NameStore; }
		}

		public string Description
		{
			get { return DescriptionStore; }
		}

		public string Author
		{
			get { return AuthorStore; }
		}

		public string Version
		{
			get { return VersionStore; }
		}

		public string Location
		{
			get { return LocationStore; }
		}

		public Type Type
		{
			get { return TypeStore; }
		}

		public object Create()
		{
			return Activator.CreateInstance( Type );
		}
	}
}