﻿using NUnit.Framework;

namespace Tomham.IO.FileManipulation.Test
{
	[TestFixture]
	public class NotConditionTest
	{
		#region Setup/Teardown

		[SetUp]
		public void SetUp()
		{
			TestHelper.SetUp();
		}

		#endregion

		[Test]
		public void ConditionIsFalse()
		{
			NotCondition notCondition = new NotCondition();

			notCondition.Condition = new FalseCondition();

			Assert.IsTrue( notCondition.IsMatch( TestHelper.GetArguments() ) );
		}

		[Test]
		public void ConditionIsTrue()
		{
			NotCondition notCondition = new NotCondition();

			notCondition.Condition = new TrueCondition();

			Assert.IsFalse( notCondition.IsMatch( TestHelper.GetArguments() ) );
		}

		[Test]
		public void Create()
		{
			NotCondition notCondition = new NotCondition();

			Assert.IsFalse( notCondition.IsMatch( TestHelper.GetArguments() ) );
		}
	}
}