﻿using NUnit.Framework;

namespace Tomham.IO.FileManipulation.Test
{
	[TestFixture]
	public class OrConditionTest
	{
		#region Setup/Teardown

		[SetUp]
		public void SetUp()
		{
			TestHelper.SetUp();
		}

		#endregion

		[Test]
		public void ConditionAllFalse()
		{
			OrCondition orCondition = new OrCondition();

			orCondition.Add( new FalseCondition() );
			orCondition.Add( new FalseCondition() );

			Assert.IsFalse( orCondition.IsMatch( TestHelper.GetArguments() ) );
		}

		[Test]
		public void ConditionAllTrue()
		{
			OrCondition orCondition = new OrCondition();

			orCondition.Add( new TrueCondition() );
			orCondition.Add( new TrueCondition() );

			Assert.IsTrue( orCondition.IsMatch( TestHelper.GetArguments() ) );
		}

		[Test]
		public void ConditionCountIsZero()
		{
			OrCondition orCondition = new OrCondition();

			Assert.AreEqual( 0, orCondition.Count );
			Assert.IsFalse( orCondition.IsMatch( TestHelper.GetArguments() ) );
		}

		[Test]
		public void ConditionTrueAndFalse()
		{
			OrCondition orCondition = new OrCondition();

			orCondition.Add( new TrueCondition() );
			orCondition.Add( new FalseCondition() );

			Assert.IsTrue( orCondition.IsMatch( TestHelper.GetArguments() ) );
		}
	}
}