﻿using System;

namespace Tomham.IO
{
	public class EditableItemInformation<T>
	{
		private string FileNameStore;

		private T ItemStore;

		public EditableItemInformation( T item )
		{
			Item = item;
		}

		public T Item
		{
			get { return ItemStore; }
			set { SetItem( value ); }
		}

		public string FileName
		{
			get
			{
				if ( FileNameStore == null )
				{
					FileNameStore = string.Empty;
				}

				return FileNameStore;
			}
			set { FileNameStore = value; }
		}

		public bool Modified { get; set; }

		private void SetItem( T value )
		{
			if ( value == null )
			{
				throw new ArgumentNullException( "value" );
			}

			ItemStore = value;
		}

		public override string ToString()
		{
			return Item.ToString();
		}
	}
}