﻿using System;

namespace Tomham.IO.FileManipulation
{
	[Serializable]
	public class AndCondition : ComplexCondition
	{
		public override bool IsMatch( MatchArguments arguments )
		{
			if ( Count == 0 )
			{
				return false;
			}

			foreach ( ICondition condition in this )
			{
				if ( !condition.IsMatch( arguments ) )
				{
					return false;
				}
			}

			return true;
		}

		public override ICondition Clone()
		{
			ComplexCondition clone = new AndCondition();

			foreach ( ICondition condition in this )
			{
				clone.Add( condition.Clone() );
			}

			return clone;
		}
	}
}