﻿using System;

namespace Tomham.IO.FileManipulation
{
	[Serializable]
	public class NotCondition : ICondition
	{
		private ICondition ConditionStore;

		public ICondition Condition
		{
			get
			{
				if ( ConditionStore == null )
				{
					ConditionStore = new TrueCondition();
				}

				return ConditionStore;
			}
			set { ConditionStore = value; }
		}

		#region ICondition Members

		public bool IsMatch( MatchArguments arguments )
		{
			return !Condition.IsMatch( arguments );
		}

		public ICondition Clone()
		{
			NotCondition clone = new NotCondition();

			clone.Condition = Condition.Clone();

			return clone;
		}

		#endregion
	}
}