﻿using System;
using System.Text.RegularExpressions;

namespace Tomham.IO.FileManipulation
{
	[Serializable]
	public class RegExCondition : TextCondition
	{
		public override ICondition Clone()
		{
			return (ICondition) MemberwiseClone();
		}

		protected override bool IsMatch( string target )
		{
			RegexOptions options = RegexOptions.None;

			if ( IgnoreCase )
			{
				options = RegexOptions.IgnoreCase;
			}

			return Regex.IsMatch( target, Pattern, options );
		}
	}
}