﻿using System;

namespace Tomham.Windows.Forms.AutoGeneration
{
	public abstract class ControllerFactory
	{
		private ControllerFactory Next { get; set; }

		public ControllerFactory SetNext(ControllerFactory next)
		{
			Next = next;

			return next;
		}

		protected abstract bool IsTarget( object target );
		protected abstract Controller DoCreate( object target );

		public Controller Create( object target )
		{
			if ( IsTarget( target ) )
			{
				return DoCreate( target );
			}

			if ( Next != null )
			{
				return Next.Create( target );
			}

			throw new InvalidOperationException( "Controller type for target was not found." );
		}
	}
}