using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace Tomham.Windows.Forms
{
    // ǂlĂ݌v~X

    public partial class FindReplaceDialog : Form
    {
        public FindReplaceDialog()
        {
            InitializeComponent();

			this.comboBoxTargetString.Select();
        }
		
        public bool CaseSensitive
        {
            get
            {
                return this.checkBoxCaseSensitive.Checked;
            }
            set
            {
                this.checkBoxCaseSensitive.Checked = value;
            }
        }

        public bool UseRegExp
        {
            get
            {
                return this.checkBoxUseRegExp.Checked;
            }
            set
            {
                this.checkBoxUseRegExp.Checked = value;
            }
        }

        public bool WholeWord
        {
            get
            {
                return this.checkBoxWholeWord.Checked;
            }
            set
            {
                this.checkBoxWholeWord.Checked = value;
            }
        }

		public bool ReplaceBeforeConfirm
		{
			get
			{
				return this.checkBoxReplaceBeforeConfirm.Checked;
			}
			set
			{
				this.checkBoxReplaceBeforeConfirm.Checked = value;
			}
		}

        public string TargetString
        {
            get
            {
                return this.comboBoxTargetString.Text;
            }
            set
            {
                this.comboBoxTargetString.Text = value;
            }
        }

        public string ReplaceString
        {
            get
            {
                return this.comboBoxReplaceString.Text;
            }
            set
            {
                this.comboBoxReplaceString.Text = value;
            }
        }

        public System.Windows.Forms.ComboBox.ObjectCollection
            TargetStringComboBoxItems
        {
            get
            {
                return this.comboBoxTargetString.Items;
            }
        }

        public System.Windows.Forms.ComboBox.ObjectCollection
            ReplaceStringComboBoxItems
        {
            get
            {
                return this.comboBoxReplaceString.Items;
            }
        }

        public Tomham.Windows.Forms.SearchDirection SearchDirection
        {
            get
            {
                if ( this.radioButtonUpDirection.Checked )
                {
                    return Tomham.Windows.Forms.SearchDirection.Up;
                }
                else
                {
                    return Tomham.Windows.Forms.SearchDirection.Down;
                }
            }

            set
            {
                if ( value == Tomham.Windows.Forms.SearchDirection.Up )
                {
                    this.radioButtonUpDirection.Checked = true;
                }
                else
                {
                    this.radioButtonDownDirection.Checked = true;
                }
            }
        }

        #region ShowComponent Properties

        public bool ShowCaseSensitiveCheckBox
        {
            get
            {
                return this.checkBoxCaseSensitive.Visible;
            }
            set
            {
                this.checkBoxCaseSensitive.Visible = value;
                this.AdjustComponentsSizeAndPosition();
            }
        }

        public bool ShowUseRegExpCheckBox
        {
            get
            {
                return this.checkBoxUseRegExp.Visible;
            }
            set
            {
                this.checkBoxUseRegExp.Visible = value;
                this.AdjustComponentsSizeAndPosition();
            }
        }

        public bool ShowWholeWordCheckBox
        {
            get
            {
                return this.checkBoxWholeWord.Visible;
            }
            set
            {
                this.checkBoxWholeWord.Visible = value;
                this.AdjustComponentsSizeAndPosition();
            }
        }

		public bool ShowReplaceBeforeConfirmCheckBox
		{
			get
			{
				return this.checkBoxReplaceBeforeConfirm.Visible;
			}
			set
			{
				this.checkBoxReplaceBeforeConfirm.Visible = value;
				this.AdjustComponentsSizeAndPosition();
			}
		}

        public bool ShowFindButton
        {
            get
            {
                return this.buttonFind.Visible;
            }
            set
            {
                this.buttonFind.Visible = value;
                this.AdjustComponentsSizeAndPosition();
            }
        }

        public bool ShowReplaceButton
        {
            get
            {
                return this.buttonReplace.Visible;
            }
            set
            {
                this.buttonReplace.Visible = value;
                this.AdjustComponentsSizeAndPosition();
            }
        }

        public bool ShowReplaceAllButton
        {
            get
            {
                return this.buttonReplaceAll.Visible;
            }
            set
            {
                this.buttonReplaceAll.Visible = value;
                this.AdjustComponentsSizeAndPosition();
            }
        }

        public bool ShowReplaceStringComboBox
        {
            get
            {
                return this.panelReplaceString.Visible;
            }
            set
            {
                this.panelReplaceString.Visible = value;
                this.AdjustComponentsSizeAndPosition();
            }
        }

        public bool ShowSearchDirectionGroupBox
        {
            get
            {
                return this.groupBoxSearchDirection.Visible;
            }
            set
            {
                this.groupBoxSearchDirection.Visible = value;
                this.AdjustComponentsSizeAndPosition();
            }
        }

        #endregion

        #region ButtonClickEvents

        public event EventHandler FindButtonClick
        {
            add
            {
                this.buttonFind.Click += value;
            }
            remove
            {
                this.buttonFind.Click -= value;
            }
        }

        public event EventHandler ReplaceButtonClick
        {
            add
            {
                this.buttonReplace.Click += value;
            }
            remove
            {
                this.buttonReplace.Click -= value;
            }
        }

        public event EventHandler ReplaceAllButtonClick
        {
            add
            {
                this.buttonReplaceAll.Click += value;
            }
            remove
            {
                this.buttonReplaceAll.Click -= value;
            }
        }

        #endregion

        #region buttonCancel_Click

        private void buttonCancel_Click( object sender, EventArgs e )
        {
			this.DialogResult = DialogResult.Cancel;
        }

        #endregion

        protected override void OnLoad( EventArgs e )
        {
            base.OnLoad( e );

            this.MoveToScreenCenter();
        }

        protected override void OnShown( EventArgs e )
        {
            base.OnShown( e );

            this.AdjustComponentsSizeAndPosition();
        }

        private const int COMPONENTS_MARGIN = 6;

        protected virtual void AdjustComponentsSizeAndPosition()
        {
            if ( ! this.Visible )
            {
                return;
            }

            this.AdjustContainerControl( this.panelCheckBoxes, COMPONENTS_MARGIN );
            this.AdjustContainerControl( this.panelComboBoxes, COMPONENTS_MARGIN );
            this.AdjustContainerControl( this.panelButtons, COMPONENTS_MARGIN );

            this.panelCheckBoxes.Top = this.panelComboBoxes.Bottom + COMPONENTS_MARGIN;
            this.groupBoxSearchDirection.Top = this.panelCheckBoxes.Top;
        }

        private void AdjustContainerControl( 
            System.Windows.Forms.Control targetControl, int margin )
        {
            int currentTop = 0;

            foreach ( System.Windows.Forms.Control child in targetControl.Controls )
            {               
                if ( child.Visible )
                {
                    child.Top = currentTop;
                    currentTop = currentTop + child.Height + margin;
                    child.Left = 0;
                }
            }

            targetControl.Height = currentTop;
        }

        #region MoveToScreenCenter

        public void MoveToScreenCenter()
        {
            Screen primaryScreen = Screen.PrimaryScreen;
            Rectangle screenRect = primaryScreen.Bounds;

            this.Top = screenRect.Height / 2 - this.Height / 2;
            this.Left = screenRect.Width / 2 - this.Width / 2;
        }

        #endregion

    }
}