using System.Collections.Generic;
using NUnit.Framework;

namespace Tomham.Tests
{
	[TestFixture]
	public class TemplateBasedFactoryTest
	{
		[Test]
		public void Create()
		{
			ItemFactory factory = new ItemFactory();
			ItemTemplate penTemplate = new ItemTemplate( "Pen", 100 );
			ItemTemplate noteTemplate = new ItemTemplate( "Note", 80 );

			factory.Add( 0, penTemplate );
			factory.Add( 1, noteTemplate );

			Item pen = factory.Create( 0 );

			Assert.AreEqual( penTemplate.Name, pen.Name );
			Assert.AreEqual( penTemplate.Price, pen.Price );

			Item note = factory.Create( 1 );

			Assert.AreEqual( noteTemplate.Name, note.Name );
			Assert.AreEqual( noteTemplate.Price, note.Price );
		}

		[Test]
		[ExpectedException( typeof ( KeyNotFoundException ) )]
		public void CreateWithUnExistedIdentifier()
		{
			ItemFactory factory = new ItemFactory();

			factory.Create( 100 );
		}
	}
}